/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the BadRequestDetailsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BadRequestDetailsInner{}

// BadRequestDetailsInner struct for BadRequestDetailsInner
type BadRequestDetailsInner struct {
	// Invalid value
	Msg *string `json:"msg,omitempty"`
	// The name of the parameter with the error
	Param *string `json:"param,omitempty"`
	// The location of the parameter
	Location *string `json:"location,omitempty"`
}

// NewBadRequestDetailsInner instantiates a new BadRequestDetailsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBadRequestDetailsInner() *BadRequestDetailsInner {
	this := BadRequestDetailsInner{}
	return &this
}

// NewBadRequestDetailsInnerWithDefaults instantiates a new BadRequestDetailsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBadRequestDetailsInnerWithDefaults() *BadRequestDetailsInner {
	this := BadRequestDetailsInner{}
	return &this
}

// GetMsg returns the Msg field value if set, zero value otherwise.
func (o *BadRequestDetailsInner) GetMsg() string {
	if o == nil || IsNil(o.Msg) {
		var ret string
		return ret
	}
	return *o.Msg
}

// GetMsgOk returns a tuple with the Msg field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BadRequestDetailsInner) GetMsgOk() (*string, bool) {
	if o == nil || IsNil(o.Msg) {
		return nil, false
	}
	return o.Msg, true
}

// HasMsg returns a boolean if a field has been set.
func (o *BadRequestDetailsInner) HasMsg() bool {
	if o != nil && !IsNil(o.Msg) {
		return true
	}

	return false
}

// SetMsg gets a reference to the given string and assigns it to the Msg field.
func (o *BadRequestDetailsInner) SetMsg(v string) {
	o.Msg = &v
}

// GetParam returns the Param field value if set, zero value otherwise.
func (o *BadRequestDetailsInner) GetParam() string {
	if o == nil || IsNil(o.Param) {
		var ret string
		return ret
	}
	return *o.Param
}

// GetParamOk returns a tuple with the Param field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BadRequestDetailsInner) GetParamOk() (*string, bool) {
	if o == nil || IsNil(o.Param) {
		return nil, false
	}
	return o.Param, true
}

// HasParam returns a boolean if a field has been set.
func (o *BadRequestDetailsInner) HasParam() bool {
	if o != nil && !IsNil(o.Param) {
		return true
	}

	return false
}

// SetParam gets a reference to the given string and assigns it to the Param field.
func (o *BadRequestDetailsInner) SetParam(v string) {
	o.Param = &v
}

// GetLocation returns the Location field value if set, zero value otherwise.
func (o *BadRequestDetailsInner) GetLocation() string {
	if o == nil || IsNil(o.Location) {
		var ret string
		return ret
	}
	return *o.Location
}

// GetLocationOk returns a tuple with the Location field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BadRequestDetailsInner) GetLocationOk() (*string, bool) {
	if o == nil || IsNil(o.Location) {
		return nil, false
	}
	return o.Location, true
}

// HasLocation returns a boolean if a field has been set.
func (o *BadRequestDetailsInner) HasLocation() bool {
	if o != nil && !IsNil(o.Location) {
		return true
	}

	return false
}

// SetLocation gets a reference to the given string and assigns it to the Location field.
func (o *BadRequestDetailsInner) SetLocation(v string) {
	o.Location = &v
}

func (o BadRequestDetailsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BadRequestDetailsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Msg) {
		toSerialize["msg"] = o.Msg
	}
	if !IsNil(o.Param) {
		toSerialize["param"] = o.Param
	}
	if !IsNil(o.Location) {
		toSerialize["location"] = o.Location
	}
	return toSerialize, nil
}

type NullableBadRequestDetailsInner struct {
	value *BadRequestDetailsInner
	isSet bool
}

func (v NullableBadRequestDetailsInner) Get() *BadRequestDetailsInner {
	return v.value
}

func (v *NullableBadRequestDetailsInner) Set(val *BadRequestDetailsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableBadRequestDetailsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableBadRequestDetailsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBadRequestDetailsInner(val *BadRequestDetailsInner) *NullableBadRequestDetailsInner {
	return &NullableBadRequestDetailsInner{value: val, isSet: true}
}

func (v NullableBadRequestDetailsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBadRequestDetailsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


